#include "hippogryf.h"

#include <QtGui>
#include <QtWidgets>

class GryfApp;

class GryfCell : public QLabel {
public:
	GryfApp *app;
	int i, j;
	void render();
	void render_entry(insn *ins, int parse_result);
	void mouseReleaseEvent(QMouseEvent *evt);
};

class GryfGrid : public QWidget {
public:
	GryfApp *app;
	void keyPressEvent(QKeyEvent *evt);
};

class GryfMain : public QWidget {
	Q_OBJECT;
public:
	GryfApp *app;
	void keyPressEvent(QKeyEvent *evt);
};

class GryfApp : public QApplication {
	Q_OBJECT
public:
	GryfMain *main;
	GryfApp(int argc, char **argv);

	program *pgm;
	QVBoxLayout *left_vbox, *right_vbox;
	QHBoxLayout *main_hbox;
	QGridLayout *cell_grid;
	GryfGrid *grid_widget;
	GryfCell *cells[NUM_ROWS][NUM_COLS];

	QLineEdit *edit_team;
	QLineEdit *edit_task;

	QLabel *status_line;
	void status(const QString s);

	int cell_i, cell_j;	// -1,-1 if no cell selected
	int dir_i, dir_j;
	void activate_cell(int i, int j);
	void move_rel(int di, int dj);
	void move_abs(int i, int j);
	void set_dir(int i, int j);
	void redraw_program();

	QString entry;
	bool grid_key_press(QKeyEvent *evt);
	void type_key(QString s);
	void cancel_entry();

	QPalette palette_idle, palette_active;

	insn clipboard;

public slots:
	void task_entered();
	void team_entered();
	void new_button();
	void load_button();
	void save_button();
	void run_button();
	void show_help();
};
